Index: lib/spatial/mapbuilder/lib/util/sarissa/sarissa_ieemu_xpath.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/sarissa/sarissa_ieemu_xpath.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/util/sarissa/sarissa_ieemu_xpath.js	(revision 4307)
@@ -3,7 +3,7 @@
  * About
  * ====================================================================
  * Sarissa cross browser XML library - IE XPath Emulation 
- * @version 0.9.6.1
+ * @version 0.9.7.6
  * @author: Manos Batsis, mailto: mbatsis at users full stop sourceforge full stop net
  *
  * This script emulates Internet Explorer's selectNodes and selectSingleNode
@@ -11,30 +11,28 @@
  * is easy with IE's setProperty. 
  * USers may also map a namespace prefix to a default (unprefixed) namespace in the
  * source document with Sarissa.setXpathNamespaces
- * 
  *
+ *
  * ====================================================================
  * Licence
  * ====================================================================
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 or
- * the GNU Lesser General Public License version 2.1 as published by
- * the Free Software Foundation (your choice between the two).
+ * Sarissa is free software distributed under the GNU GPL version 2 (see <a href="gpl.txt">gpl.txt</a>) or higher, 
+ * GNU LGPL version 2.1 (see <a href="lgpl.txt">lgpl.txt</a>) or higher and Apache Software License 2.0 or higher 
+ * (see <a href="asl.txt">asl.txt</a>). This means you can choose one of the three and use that if you like. If 
+ * you make modifications under the ASL, i would appreciate it if you submitted those.
+ * In case your copy of Sarissa does not include the license texts, you may find
+ * them online in various formats at <a href="http://www.gnu.org">http://www.gnu.org</a> and 
+ * <a href="http://www.apache.org">http://www.apache.org</a>.
  *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License or GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * or GNU Lesser General Public License along with this program; if not,
- * write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
- * or visit http://www.gnu.org
- *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY 
+ * KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
+ * WARRANTIES OF MERCHANTABILITY,FITNESS FOR A PARTICULAR PURPOSE 
+ * AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
+ * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
+ * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
+ * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  */
- var _SARISSA_HAS_DOM_IMPLEMENTATION = document.implementation && true;
- var _SARISSA_HAS_DOM_FEATURE = _SARISSA_HAS_DOM_IMPLEMENTATION && document.implementation.hasFeature;
- 
 if(_SARISSA_HAS_DOM_FEATURE && document.implementation.hasFeature("XPath", "3.0")){
     /**
     * <p>SarissaNodeList behaves as a NodeList but is only used as a result to <code>selectNodes</code>,
@@ -69,7 +67,9 @@
     */
     SarissaNodeList.prototype.expr = "";
     /** dummy, used to accept IE's stuff without throwing errors */
-    XMLDocument.prototype.setProperty  = function(x,y){};
+    if(window.XMLDocument && (!XMLDocument.prototype.setProperty)){
+        XMLDocument.prototype.setProperty  = function(x,y){};
+    };
     /**
     * <p>Programmatically control namespace URI/prefix mappings for XPath
     * queries.</p>
@@ -103,7 +103,7 @@
             var ns = namespaces[i];
             var colonPos = ns.indexOf(":");
             var assignPos = ns.indexOf("=");
-            if(colonPos == 5 && assignPos > colonPos+2){
+            if(colonPos > 0 && assignPos > colonPos+1){
                 var prefix = ns.substring(colonPos+1, assignPos);
                 var uri = ns.substring(assignPos+2, ns.length-1);
                 oDoc._sarissa_xpathNamespaces[prefix] = uri;
@@ -127,7 +127,7 @@
     * @returns the result of the XPath search as a SarissaNodeList
     * @throws An error if no namespace URI is found for the given prefix.
     */
-    XMLDocument.prototype.selectNodes = function(sExpr, contextNode){
+    XMLDocument.prototype.selectNodes = function(sExpr, contextNode, returnSingle){
         var nsDoc = this;
         var nsresolver = this._sarissa_useCustomResolver
         ? function(prefix){
@@ -136,15 +136,25 @@
             else throw "No namespace URI found for prefix: '" + prefix+"'";
             }
         : this.createNSResolver(this.documentElement);
+        var result = null;
+        if(!returnSingle){
             var oResult = this.evaluate(sExpr,
-                    (contextNode?contextNode:this),
-                    nsresolver,
-                    XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
-        var nodeList = new SarissaNodeList(oResult.snapshotLength);
-        nodeList.expr = sExpr;
-        for(var i=0;i<nodeList.length;i++)
-            nodeList[i] = oResult.snapshotItem(i);
-        return nodeList;
+                (contextNode?contextNode:this),
+                nsresolver,
+                XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
+            var nodeList = new SarissaNodeList(oResult.snapshotLength);
+            nodeList.expr = sExpr;
+            for(var i=0;i<nodeList.length;i++)
+                nodeList[i] = oResult.snapshotItem(i);
+            result = nodeList;
+        }
+        else {
+            result = oResult = this.evaluate(sExpr,
+                (contextNode?contextNode:this),
+                nsresolver,
+                XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
+        };
+        return result;      
     };
     /**
     * <p>Extends the Element to emulate IE's selectNodes</p>
@@ -162,7 +172,7 @@
             throw "Method selectNodes is only supported by XML Elements";
     };
     /**
-    * <p>Extends the XMLDocument to emulate IE's selectSingleNodes.</p>
+    * <p>Extends the XMLDocument to emulate IE's selectSingleNode.</p>
     * @argument sExpr the XPath expression to use
     * @argument contextNode this is for internal use only by the same
     *           method when called on Elements
@@ -170,15 +180,10 @@
     */
     XMLDocument.prototype.selectSingleNode = function(sExpr, contextNode){
         var ctx = contextNode?contextNode:null;
-        sExpr = "("+sExpr+")[1]";
-        var nodeList = this.selectNodes(sExpr, ctx);
-        if(nodeList.length > 0)
-            return nodeList.item(0);
-        else
-            return null;
+        return this.selectNodes(sExpr, ctx, true);
     };
     /**
-    * <p>Extends the Element to emulate IE's selectNodes.</p>
+    * <p>Extends the Element to emulate IE's selectSingleNode.</p>
     * @argument sExpr the XPath expression to use
     * @returns the result of the XPath search as an (Sarissa)NodeList
     * @throws An error if invoked on an HTML Element as this is only be
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31297.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31297.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31297.js	(revision 4307)
@@ -0,0 +1,3 @@
+//# MGI / Austria Lambert
+//<31297> +proj=lcc +lat_1=49 +lat_2=46 +lat_0=47.5 +lon_0=13.33333333333333 +x_0=400000 +y_0=400000 +ellps=bessel +units=m +no_defs  <>
+Proj4js.defs["EPSG:31297"] = "+title=MGI / Austria Lambert EPSG:31297 +proj=lcc +lat_1=49 +lat_2=46 +lat_0=47.5 +lon_0=13.33333333333333 +x_0=400000 +y_0=400000 +ellps=bessel +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32758.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32758.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32758.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32758"] = "+proj=utm +zone=58 +south +ellps=WGS84 +datum=WGS84 +units=m +no_defs ";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG41001.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG41001.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG41001.js	(revision 4307)
@@ -0,0 +1,2 @@
+Proj4js.defs["EPSG:41001"] = "+title=simple mercator EPSG:41001\
+  +proj=merc +lat_ts=0 +lon_0=0 +k=1.000000 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32612.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32612.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32612.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32612"] = "+title=WGS 84 / UTM zone 12N epsg:32612 +proj=utm +zone=12 +ellps=WGS84 +datum=WGS84 +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG27700.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG27700.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG27700.js	(revision 4307)
@@ -0,0 +1,4 @@
+//# OSGB 1936 / British National Grid
+//<27700> +proj=tmerc +lat_0=49 +lon_0=-2 +k=0.999601 +x_0=400000 +y_0=-100000 +ellps=airy +units=m +no_defs  no_defs <>
+Proj4js.defs["EPSG:27700"] = "+title=OSGB 1936 / British National Grid / EPSG:27700\
++proj=tmerc +lat_0=49 +lon_0=-2 +k=0.999601 +x_0=400000 +y_0=-100000 +ellps=airy +units=m ";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32616.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32616.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32616.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32616"] = "+title=WGS 84 / UTM zone 16N epsg:32616 +proj=utm +zone=16 +ellps=WGS84 +datum=WGS84 +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31286.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31286.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31286.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31286"] = "+title=MGI / M34 EPSG:31286 +proj=tmerc +lat_0=0 +lon_0=16.33333333333333 +k=1.000000 +x_0=750000 +y_0=0 +ellps=bessel +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/GOOGLE.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/GOOGLE.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/GOOGLE.js	(revision 4307)
@@ -0,0 +1,2 @@
+Proj4js.defs["GOOGLE"]="+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +no_defs";
+Proj4js.defs["EPSG:900913"]=Proj4js.defs["GOOGLE"];
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG4139.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG4139.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG4139.js	(revision 4307)
@@ -0,0 +1,4 @@
+Proj4js.defs["EPSG:4139"] = "+title=Puerto Rico EPSG:4139 (3 param datum shift)\
+  +proj=longlat \
+  +towgs84 = 11,72,-101,0,0,0,0 \
+  +a=6378206.4 +b=6356583.8 \";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG54021.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG54021.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG54021.js	(revision 4307)
@@ -0,0 +1,7 @@
+//<54021> +proj=poly +lat_0=0 +lon_0=0 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m 
+Proj4js.defs["EPSG:54021"]= "\
+  +title= World polyconic EPSG:54021\
+  +proj=poly \
+  +lon_0=0 +x_0=0 +y_0=0 \
+  +ellps=WGS84 +datum=WGS84 +units=m \
+";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG27582.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG27582.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG27582.js	(revision 4307)
@@ -0,0 +1,16 @@
+//
+//# USA Contiguous Equidistant Conic
+//<102005> +proj=eqdc +lat_0=0 +lon_0=0 +lat_1=33 +lat_2=45 +x_0=0 +y_0=0 +ellps=GRS80 +datum=NAD83 +units=m 
+
+Proj4js.defs["EPSG:27582"] = "+proj=lcc \
+ +lat_1=46.8  \
+ +lat_0=46.8  +lon_0=0  \
+ +k_0=0.99987742  \
+ +x_0=600000  +y_0=2200000  \
+ +a=6378249.2  +b=6356515  \
+ +towgs84=-168,-60,320,0,0,0,0  \
+ +pm=paris  \
+ +units=m +no_defs  \
+  ";
+
+
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG28992.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG28992.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG28992.js	(revision 4307)
@@ -0,0 +1,3 @@
+//# Amersfoort / RD New
+//<28992> +proj=stere +lat_0=52.15616055555555 +lon_0=5.38763888888889 +k=0.999908 +x_0=155000 +y_0=463000 +ellps=bessel +units=m +no_defs  no_defs <>
+Proj4js.defs["EPSG:28992"] = "+title=Amersfoort / RD New EPSG:28992 +proj=stere +lat_0=52.15616055555555 +lon_0=5.38763888888889 +k=0.999908 +x_0=155000 +y_0=463000 +ellps=bessel +units=m";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102758.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102758.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102758.js	(revision 4307)
@@ -0,0 +1,6 @@
+Proj4js.defs["EPSG:102758"] = "+title=NAD 1983 StatePlane Wyoming West FIPS 4904 Feet\
+  +proj=tmerc \
+  +lat_0=40.5  +lon_0=-110.0833333333333 \
+  +x_0=800000  +y_0=100000  +k=0.999938 \
+  +a=6378137.0 +b=6356752.3141403\
+  +to_meter=0.3048006096012192 \";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32613.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32613.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32613.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32613"] = "+title=WGS 84 / UTM zone 13N epsg:32613 +proj=utm +zone=13 +ellps=WGS84 +datum=WGS84 +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32615.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32615.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32615.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32615"] = "+title=WGS 84 / UTM zone 15N epsg:32615 +proj=utm +zone=15 +ellps=WGS84 +datum=WGS84 +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31291.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31291.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31291.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31291"] = "+title=MGI (Ferro) / Austria West Zone EPSG:31291 +proj=tmerc +lat_0=0 +lon_0=28 +k=1.000000 +x_0=0 +y_0=0 +ellps=bessel +pm=ferro +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31285.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31285.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31285.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31285"] = "+title=MGI / M31 EPSG:31285 +proj=tmerc +lat_0=0 +lon_0=13.33333333333333 +k=1.000000 +x_0=450000 +y_0=0 +ellps=bessel +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31293.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31293.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31293.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31293"] = "+title=MGI (Ferro) / Austria East Zone EPSG:31293 +proj=tmerc +lat_0=0 +lon_0=34 +k=1.000000 +x_0=0 +y_0=0 +ellps=bessel +pm=ferro +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31295.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31295.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31295.js	(revision 4307)
@@ -0,0 +1,3 @@
+//# MGI / M31
+//<31295> +proj=tmerc +lat_0=0 +lon_0=13.33333333333333 +k=1.000000 +x_0=450000 +y_0=0 +ellps=bessel +units=m +no_defs  <>
+Proj4js.defs["EPSG:31295"] = "+title=MGI / M31 EPSG:31295 +proj=tmerc +lat_0=0 +lon_0=13.33333333333333 +k=1.000000 +x_0=450000 +y_0=0 +ellps=bessel +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/sarissa/sarissa_dhtml.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/sarissa/sarissa_dhtml.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/util/sarissa/sarissa_dhtml.js	(revision 4307)
@@ -1,9 +1,9 @@
-/** 
+/**
  * ====================================================================
  * About
  * ====================================================================
  * Sarissa cross browser XML library - AJAX module
- * @version 0.9.6.1
+ * @version 0.9.7.6
  * @author: Copyright Manos Batsis, mailto: mbatsis at users full stop sourceforge full stop net
  *
  * This module contains some convinient AJAX tricks based on Sarissa 
@@ -11,62 +11,81 @@
  * ====================================================================
  * Licence
  * ====================================================================
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 or
- * the GNU Lesser General Public License version 2.1 as published by
- * the Free Software Foundation (your choice between the two).
+ * Sarissa is free software distributed under the GNU GPL version 2 (see <a href="gpl.txt">gpl.txt</a>) or higher, 
+ * GNU LGPL version 2.1 (see <a href="lgpl.txt">lgpl.txt</a>) or higher and Apache Software License 2.0 or higher 
+ * (see <a href="asl.txt">asl.txt</a>). This means you can choose one of the three and use that if you like. If 
+ * you make modifications under the ASL, i would appreciate it if you submitted those.
+ * In case your copy of Sarissa does not include the license texts, you may find
+ * them online in various formats at <a href="http://www.gnu.org">http://www.gnu.org</a> and 
+ * <a href="http://www.apache.org">http://www.apache.org</a>.
  *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License or GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * or GNU Lesser General Public License along with this program; if not,
- * write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
- * or visit http://www.gnu.org
- *
+  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY 
+  * KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
+  * WARRANTIES OF MERCHANTABILITY,FITNESS FOR A PARTICULAR PURPOSE 
+  * AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
+  * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
+  * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
+  * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  */
+/** @private */
+Sarissa.updateCursor = function(oTargetElement, sValue) {
+    if(oTargetElement && oTargetElement.style && oTargetElement.style.cursor != undefined ){
+        oTargetElement.style.cursor = sValue;
+    };
+};
+
 /**
- * Update an element with response of a GET request on the given URL. 
+ * Update an element with response of a GET request on the given URL.  Passing a configured XSLT 
+ * processor will result in transforming and updating oNode before using it to update oTargetElement.
+ * You can also pass a callback function to be executed when the update is finished. The function will be called as 
+ * <code>functionName(oNode, oTargetElement);</code>
  * @addon
  * @param sFromUrl the URL to make the request to
  * @param oTargetElement the element to update
  * @param xsltproc (optional) the transformer to use on the returned
  *                  content before updating the target element with it
+ * @param callback (optional) a Function object to execute once the update is finished successfuly, called as <code>callback(oNode, oTargetElement)</code>
+ * @param skipCache (optional) whether to skip any cache
  */
-Sarissa.updateContentFromURI = function(sFromUrl, oTargetElement, xsltproc) {
+Sarissa.updateContentFromURI = function(sFromUrl, oTargetElement, xsltproc, callback, skipCache) {
     try{
-        oTargetElement.style.cursor = "wait";
+        Sarissa.updateCursor(oTargetElement, "wait");
         var xmlhttp = new XMLHttpRequest();
         xmlhttp.open("GET", sFromUrl);
         function sarissa_dhtml_loadHandler() {
             if (xmlhttp.readyState == 4) {
-                oTargetElement.style.cursor = "auto";
-                Sarissa.updateContentFromNode(xmlhttp.responseXML, oTargetElement, xsltproc);
+                Sarissa.updateContentFromNode(xmlhttp.responseXML, oTargetElement, xsltproc, callback);
             };
         };
         xmlhttp.onreadystatechange = sarissa_dhtml_loadHandler;
-        xmlhttp.send(null);
-        oTargetElement.style.cursor = "auto";
+        if (skipCache) {
+             var oldage = "Sat, 1 Jan 2000 00:00:00 GMT";
+             xmlhttp.setRequestHeader("If-Modified-Since", oldage);
+        };
+        xmlhttp.send("");
     }
     catch(e){
-        oTargetElement.style.cursor = "auto";
+        Sarissa.updateCursor(oTargetElement, "auto");
         throw e;
     };
 };
 
 /**
- * Update an element's content with the given DOM node.
+ * Update an element's content with the given DOM node. Passing a configured XSLT 
+ * processor will result in transforming and updating oNode before using it to update oTargetElement.
+ * You can also pass a callback function to be executed when the update is finished. The function will be called as 
+ * <code>functionName(oNode, oTargetElement);</code>
  * @addon
- * @param sFromUrl the URL to make the request to
+ * @param oNode the URL to make the request to
  * @param oTargetElement the element to update
  * @param xsltproc (optional) the transformer to use on the given 
  *                  DOM node before updating the target element with it
+ * @param callback (optional) a Function object to execute once the update is finished successfuly, called as <code>callback(oNode, oTargetElement)</code>
  */
-Sarissa.updateContentFromNode = function(oNode, oTargetElement, xsltproc) {
+Sarissa.updateContentFromNode = function(oNode, oTargetElement, xsltproc, callback) {
     try {
-        oTargetElement.style.cursor = "wait";
+        Sarissa.updateCursor(oTargetElement, "wait");
         Sarissa.clearChildNodes(oTargetElement);
         // check for parsing errors
         var ownerDoc = oNode.nodeType == Node.DOCUMENT_NODE?oNode:oNode.ownerDocument;
@@ -81,13 +100,13 @@
                 oNode = xsltproc.transformToDocument(oNode);
             };
             // be smart, maybe the user wants to display the source instead
-            if(oTargetElement.tagName.toLowerCase == "textarea" || oTargetElement.tagName.toLowerCase == "input") {
-                oTargetElement.value = Sarissa.serialize(oNode);
+            if(oTargetElement.tagName.toLowerCase() == "textarea" || oTargetElement.tagName.toLowerCase() == "input") {
+                oTargetElement.value = new XMLSerializer().serializeToString(oNode);
             }
             else {
                 // ok that was not smart; it was paranoid. Keep up the good work by trying to use DOM instead of innerHTML
                 if(oNode.nodeType == Node.DOCUMENT_NODE || oNode.ownerDocument.documentElement == oNode) {
-                    oTargetElement.innerHTML = Sarissa.serialize(oNode);
+                    oTargetElement.innerHTML = new XMLSerializer().serializeToString(oNode);
                 }
                 else{
                     oTargetElement.appendChild(oTargetElement.ownerDocument.importNode(oNode, true));
@@ -94,12 +113,15 @@
                 };
             };  
         };
+        if (callback) {
+            callback(oNode, oTargetElement);
+        };
     }
     catch(e) {
-        throw e;
+            throw e;
     }
     finally{
-        oTargetElement.style.cursor = "auto";
+        Sarissa.updateCursor(oTargetElement, "auto");
     };
 };
 
